package com.github.marcoferrer.krotoplus.generators

import com.squareup.kotlinpoet.FileSpec
import com.squareup.wire.schema.Schema
import kotlinx.cli.CommandLineInterface
import kotlinx.coroutines.experimental.Job
import kotlinx.coroutines.experimental.channels.SendChannel
import java.io.File

interface GeneratorModule{

    val isEnabled: Boolean

    val resultChannel: SendChannel<GeneratorResult>

    fun bindToCli(mainCli: CommandLineInterface)

    fun generate(schema: Schema): Job

    companion object {
        const val AutoGenerationDisclaimer = "THIS IS AN AUTOGENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY."
    }
}

data class GeneratorResult(val fileSpec: FileSpec, val outputDir:File)

